| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | Static Public Member Functions | List of all members
nkWinUi::EditBox Class Referenceabstract

A graphical single line edit box. More...

Inheritance diagram for nkWinUi::EditBox:

## Public Member Functions
| EditBox (System *system) noexcept
virtual | ~EditBox ()
std::function< bool(EditBox *, const CharEventData &)> | getCharCallback () const
virtual void | setOnlyNumbers (bool value)
virtual void | setPlaceHolder (nkMemory::StringView text)
virtual void | setCaretPosition (unsigned int letterIndex)=0
void | setCharCallback (std::function< bool(EditBox *, const CharEventData &)> value)
virtual void | exportIntrospection (nkExport::Node *rootNode) override
virtual void | importClassFromTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkWinUi::Component
| Component (System *system) noexcept
virtual | ~Component ()
Layout * | getLayout () const
Theme * | getTheme () const
Font * | getFont () const
nkMaths::Point | getPositionInParent () const
nkMaths::Point | getPositionInScreen () const
float | getWidth () const
float | getHeight () const
nkMaths::Rectangle | getAreaInParent () const
nkMaths::Rectangle | getAreaInScreen () const
virtual nkMaths::Point | getBorderExtents () const
virtual float | getBorderExtent (BORDER_KIND border) const
virtual float | getLayoutAllowedWidth () const
virtual float | getLayoutAllowedHeight () const
virtual float | getLayoutAllowedOffsetX () const
virtual float | getLayoutAllowedOffsetY () const
bool | isInitialized () const
System * | getSystem () const
Component * | getParentComponent () const
COMPONENT_TYPE | getComponentType () const
nkMemory::StringView | getComponentName () const
bool | getVisibility () const
virtual nkMemory::StringView | getLabel () const
void * | getData () const
bool | isEnabled () const
bool | isForegroundWindow () const
virtual unsigned int | getZDepth () const
bool | getVisibleOnLoad () const
std::function< bool(Component *)> | getCloseCallback () const
std::function< void(Component *, bool)> | getVisibilityCallback () const
std::function< void(Component *, const ClickEventData &)> | getClickCallback () const
std::function< void(Component *, const WheelEventData &)> | getWheelCallback () const
std::function< void(Component *, const KeyEventData &)> | getKeyCallback () const
virtual Layout * | setLayout (LAYOUT_TYPE layoutType)
virtual void | setTheme (Theme *theme)
virtual void | setFont (Font *font)
virtual void | setPositionInParent (nkMaths::Point position)
virtual void | setPositionInScreen (nkMaths::Point position)
virtual void | setSize (float width, float height)
virtual void | setWidth (float width)
virtual void | setHeight (float height)
void | setMinSize (float width, float height)
void | setMaxSize (float width, float height)
void | setRatio (float widthOverHeight)
virtual void | setAreaInParent (const nkMaths::Rectangle &area)
virtual void | setAreaInScreen (const nkMaths::Rectangle &area)
virtual void | setParentComponent (Component *parent, bool makeItVisible=true)
virtual void | setLabel (nkMemory::StringView label)
void | setComponentName (nkMemory::StringView name)
virtual void | setVisibility (bool value)
void | setData (void *data)
void | setEnabled (bool value)
void | setVisibleOnLoad (bool value)
void | setCloseCallback (std::function< bool(Component *caller)> callback)
void | setVisibilityCallback (std::function< void(Component *caller, bool visibility)> callback)
void | setClickCallback (std::function< void(Component *caller, const ClickEventData &eventData)> callback)
void | setWheelCallback (std::function< void(Component *caller, const WheelEventData &eventData)> callback)
void | setKeyCallback (std::function< void(Component *caller, const KeyEventData &eventData)> callback)
void | addChild (Component *child, bool makeItVisible=true)
void | removeChild (Component *child)
void | removeChild (unsigned int index)
Component * | getChild (unsigned int index)
unsigned int | getChildIndex (Component *child)
void | unloadWithChildren ()
void | loadWithChildren ()
void | updateZDepth ()
void | bringToForeground ()
void | focusWindow ()
nkMaths::Point | getCoordRelativeFromAbsolute (nkMaths::Point absCoords)
nkMaths::Point | getCoordAbsoluteFromRelative (nkMaths::Point relCoords)
virtual void | load ()=0
virtual void | unload ()=0
void | reload ()
virtual void | updateWindow ()
nkImages::Image | paintToImage (bool withFrame=false)
void | simulateEvent (const InputDescriptor &inputDescription)
virtual void | onSized ()
virtual void | exportClassToTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkExport::Exportable
| Exportable () noexcept
virtual | ~Exportable ()

## Static Public Member Functions
static nkMemory::UniquePtr< EditBox > | create (System *system=nullptr)

## Detailed Description

A graphical single line edit box.

## Constructor & Destructor Documentation

## ◆ EditBox()

nkWinUi::EditBox::EditBox | ( | System * | system | ) |
| noexcept

Constructor.

Parameters

  system | The parent system in which the component will live.

Remarks
  See ComponentManager::createOrRetrieve().

## ◆ ~EditBox()

virtual nkWinUi::EditBox::~EditBox | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getCharCallback()

std::function<bool (EditBox*, const CharEventData&)> nkWinUi::EditBox::getCharCallback | ( |  | ) | const

Returns
  The callback used when a char should be added to the edit box.

## ◆ setOnlyNumbers()

virtual void nkWinUi::EditBox::setOnlyNumbers | ( | bool | value | ) |
| virtual

Sets whether the edit box should only accept numbers in input.

Parameters

  value | If the edit box should only accept numbers (true) or not (false).

## ◆ setPlaceHolder()

virtual void nkWinUi::EditBox::setPlaceHolder | ( | nkMemory::StringView | text | ) |
| virtual

Sets the place holder shown when no text is present in the edit box.

Parameters

  text | The text to show as a place holder.

## ◆ setCaretPosition()

virtual void nkWinUi::EditBox::setCaretPosition | ( | unsigned int | letterIndex | ) |
| pure virtual

Sets the caret position within the edit box.

Parameters

  letterIndex | The index at which to set the caret. Will be clamped to the valid interval of possible positions.

## ◆ setCharCallback()

void nkWinUi::EditBox::setCharCallback | ( | std::function< bool(EditBox *, const CharEventData &)> | value | ) |

Sets the callback used whenever a character should be added to the edit box.

Parameters

  value | The callback to use. The first argument will be the calling component, the second one the event data. The callback should return true to approve the addition, or false to prevent it.

## ◆ exportIntrospection()

virtual void nkWinUi::EditBox::exportIntrospection | ( | nkExport::Node * | rootNode | ) |
| override virtual

A basic exporting capability, for components inheriting. Components inheriting this class should rather reimplement this function to export their internal data.

Parameters

  rootNode | The root of the tree to export into.

Reimplemented from nkWinUi::Component.

## ◆ importClassFromTree()

virtual void nkWinUi::EditBox::importClassFromTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

A basic importing capability.

Parameters

  rootNode | The root of the tree to import from.

Reimplemented from nkWinUi::Component.

## ◆ create()

static nkMemory::UniquePtr<EditBox> nkWinUi::EditBox::create | ( | System * | system = `nullptr` | ) |
| static

Creates a standalone component, linking it to a system, but no manager. This method can be used to allocate a component and manually manage its lifetime.

Parameters

  system | The system to create the component into. If left to nullptr, then the Singleton instance will be used.

Returns
  The created component instance.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsWinUi/Components/EditBox.h